function  [Ny, Qy,cluster_ids] = cos_col_hash2( r, b, k0,l0,Nx,Ny, Qy, DnZ )
% Compute random-projection-signatures, hash columns into buckets. 
%   

Dnz=DnZ;

Nxy = Nx' * Ny;
Pnz = Dnz./Nxy;
Dz = Nxy - Dnz;
Pz = Dz./Nxy;


s=r*b;

%generate signatures
S = zeros(s,l0);
for i=1:s
    ri = randn(1,k0);
    ri = ri/sqrt(sum(ri.^2));
    
    S(i,:) = sign(ri*Pnz);
end


% generate hash tables
% S: r*b x l0


%hash = java.util.Hashtable;
% [m,n] = size(A);
% T = min_hashing(A, r*b); % T: r*b x n


maps = cell(b,1); % holds b "hashtables"

for j = 1:b
    from = 1 + r*(j-1);
    to = from + (r-1);
%     hash.clear;

    c=containers.Map;
    
% hash all columns to hash-table j
    for i = 1:l0   
        t = S(from:to,i)';   
        t = num2str(t);  
        
        if(isKey(c,t))
            c(t) = [c(t) i];
        else
            c(t) = i;
        end
        
%         if hash.containsKey(t) == 1       
%             jList = hash.get(t);        
%             jList.add(i);
%         else              
%             jList = java.util.ArrayList;     
%             jList.add(i);    
%             hash.put(t,jList);
%         end  
    end
    
    maps{j} = c;
    
%     vals = hash.values.toArray;
%     for k = 1:vals.size
%         if vals(k).size > 1
%             if is_multiple == 0
%                 [Nx, Ny, Qy, DnZ, c0, costvar] = merge_col_bucket( vals(k), A, Nx, Ny, Qy, DnZ, c0, costvar );
%             else
%                 [Nx, Ny, Qy, DnZ, c0, costvar] = merge_col_bucket_mul( vals(k), A, Nx, Ny, Qy, DnZ, c0, costvar );
%             end
%         end
%     end
    
end % end of hashing "sub-"signatures 

clear S;



% now trying-to-merge-phase
candidategroups = 1:l0;

% process hash-tables 1 by 1
for i=1:b
    c = maps{i};
    k=c.keys;
    for j=1:length(k)
       candidategroups(c(k{j})) = min(candidategroups(c(k{j}))); 
    end
end

ucg=unique(candidategroups);
% c=sort(histc(candidategroups,ucg),'descend');
% c(1:min(5,length(c)))
%  fprintf('There are %d candidate groups\n',length(ucg));
%pause



cluster_ids = unique(Qy);
assert(length(unique(cluster_ids))==length(Ny));
assert(length(unique(cluster_ids))==sum(Ny>0));
assert(length(unique(cluster_ids))==l0);

m = length(Qy);
% try merging candidate GROUPS, don't if cost larger
for i=1:length(ucg)
    
    
    
    %locally update cost
    ind = find(candidategroups == ucg(i));
    num=length(ind);
    if(num<2)
        continue;
    end
    
%     fprintf('Candidate group of size %d...\n',num);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%% try to merge not all at once but 1 by 1
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    curl0 = l0;
    
    trials=0;
    while 1
        merged=0;
        
        %cand1 = ind(1);
        % pick a first index at random
        ix = find(Ny(ind)>0);
%         if(r==1) %pick smallest
%             [~, mind] = min(Ny(ind(ix)));
%             cand1 = ind(ix(mind));
%         else    
            fo=ix(randi(length(ix)));
            cand1 = ind(fo);
%         end
%         Ny(cand1)
%         pause
        
                
        Dnzc = Dnz(:,cand1);
        Pnzc = Pnz(:,cand1);
        Dzc = Dz(:,cand1);
        Pzc = Pz(:,cand1);
    
    for o=1:num
        % merge group-cand1 with group ind(o)?
        
            
        
        if(ismember(ind(o),cand1) || Ny(ind(o)) == 0)
            continue;
        end
        
%         if(r==1)
%             Ny(cand1)
%             Ny(ind(o))
%             pause
%         end
        %newind = [cand1 ind(o)];
    
    
        curcost = 0;
        % reduce num cluster cost
        curcost = curcost - logstar2(curl0-length(cand1)+1) + logstar2(curl0-length(cand1));

        % reduce cluster assignment cost
        cis = [sum(Ny(cand1)) Ny(ind(o))];
        
        
        curcost = curcost - sum(cis.*log2(m./cis)) + sum(cis)*log2(m./sum(cis));

        % reduce encoding cost of 1s
        curcost = curcost - sum(sum(log2(Nx'*cis+1))) + sum(log2(Nx*sum(cis)+1));

        
        assert(curcost<=0)
    
        % increase block-encoding cost, 
        % initially it was NOT 0 subtract / add
    
        % subtract
        Dnzm = [Dnzc Dnz(:,ind(o))];
        Pnzm = [Pnzc Pnz(:,ind(o))];
        Dzm = [Dzc Dz(:,ind(o))];
        Pzm = [Pzc Pz(:,ind(o))];
        entropy_terms =  Dzm .* entropy_bits(Pzm) + Dnzm .* entropy_bits(Pnzm);
        oldc = sum(sum(entropy_terms));
        curcost = curcost - oldc;

        % add
        Dnzv = sum(Dnzm,2);
        newrowsizes=Nx'*sum(cis);
        Pnzv = Dnzv ./ newrowsizes;
        Dzv = newrowsizes-Dnzv;
        Pzv = 1-Pnzv;

        entropy_terms =  Dzv .* entropy_bits(Pzv) + Dnzv .* entropy_bits(Pnzv);
        newc = (sum(entropy_terms));
        curcost = curcost + newc;
    

        assert((newc-oldc)>=0 || abs(oldc-newc) < 0.000001);


        % check if better cost
%         if(r==1)
%             fprintf('Current cost is %f, \n', curcost);
%         end
        
        if(curcost<=0) % if final cost difference less than 0, merge!
%            fprintf('Current cost is %f, merging group of size %d at %d\n', curcost, sum(cis),o);
%            cis
%            pause
           
            merged=1;
           cand1 = [cand1 ind(o)];
           
           
           Dnzc = Dnzv;
           Pnzc = Pnzv;
           Dzc = Dzv;
           Pzc = Pzv;
           
        % else %don't merge
        end
    
    end % for: iterating candidates 1 by 1

    
    if(length(cand1)>1) %%%%MERGED!
%        if(length(cand1)<num)
%         fprintf('Candidates %d, merged %d\n',num, length(cand1));
%        end
% 
%         cluster_ids
%         Ny
%         assert(length(unique(cluster_ids))==sum(Ny>0));
        
        curl0 = curl0 - length(cand1)+1;
        
    % Ny and Qy are going to change
        newind = cand1;
        cis = Ny(newind);
        
        %cluster_ids(newind)
        
        [minid minind] = min(cluster_ids(newind));
        
        Ny(newind) = 0;
        Ny(newind(minind)) = sum(cis);

        for q=1:length(newind)            
           if(cluster_ids(newind(q))~=minid)                
                Qy(Qy==cluster_ids(newind(q))) = minid; 
                cluster_ids(cluster_ids==cluster_ids(newind(q))) = minid;
           end
        end
        %cluster_ids(newind) = minid;
%         length(unique(cluster_ids))
%         sum(Ny>0)
%         cluster_ids
%         Ny
        assert(length(unique(cluster_ids))==sum(Ny>0));
       % change Dnz
       Dnz(:,newind(minind)) = Dnzc;
       Pnz(:,newind(minind)) = Pnzc;
       Dz(:,newind(minind)) = Dzc;
       Pz(:,newind(minind)) = Pzc;
       
    end
    
    if(~merged), trials=trials+1; end
    if(r==1)
        if(trials>5), break; end
    else
        if(trials>0), break; end
    end
%      fprintf('Merged !!!\n')   
%      pause
    end % while
    
end % candidate groups


end












