function  [Ny, Qy] = jac_col_hash2( A, r, b, Ny, Qy )
% Compute minimum hash, hash columns into buckets. 
%   

[n,m] = size(A);
s=r*b;
% generate permutations
M = zeros(s,n);
for i=1:s
    M(i,:) = randperm(n);    
end

%generate signatures
S = zeros(s,m);
for i=1:m
    if(sum(A(:,i)>0)>0)
        S(:,i) = min(M(:,(A(:,i)>0)),[],2);    
    end
end

clear M;

% generate hash tables
% S: r*b x m


%hash = java.util.Hashtable;
% [m,n] = size(A);
% T = min_hashing(A, r*b); % T: r*b x n


maps = cell(b,1); % holds b "hashtables"

for j = 1:b
    from = 1 + r*(j-1);
    to = from + (r-1);
%     hash.clear;

    c=containers.Map;
    
% hash all columns to hash-table j
    for i = 1:m   
        t = S(from:to,i)';   
        t = num2str(t);  
        
        if(isKey(c,t))
            c(t) = [c(t) i];
        else
            c(t) = i;
        end
        
%         if hash.containsKey(t) == 1       
%             jList = hash.get(t);        
%             jList.add(i);
%         else              
%             jList = java.util.ArrayList;     
%             jList.add(i);    
%             hash.put(t,jList);
%         end  
    end
    
    maps{j} = c;
    
%     vals = hash.values.toArray;
%     for k = 1:vals.size
%         if vals(k).size > 1
%             if is_multiple == 0
%                 [Nx, Ny, Qy, DnZ, c0, costvar] = merge_col_bucket( vals(k), A, Nx, Ny, Qy, DnZ, c0, costvar );
%             else
%                 [Nx, Ny, Qy, DnZ, c0, costvar] = merge_col_bucket_mul( vals(k), A, Nx, Ny, Qy, DnZ, c0, costvar );
%             end
%         end
%     end
    
end % end of hashing "sub-"signatures 

clear S;



% now trying-to-merge-phase
candidategroups = 1:m;

% process hash-tables 1 by 1
for i=1:b
    c = maps{i};
    k=c.keys;
    for j=1:length(k)
       candidategroups(c(k{j})) = min(candidategroups(c(k{j}))); 
    end
end

ucg=unique(candidategroups);
% c=sort(histc(candidategroups,ucg),'descend');
% c(1:min(5,length(c)))
% fprintf('There are %d candidate groups\n',length(ucg));
% pause


% try merging candidate GROUPS, don't if cost larger
for i=1:length(ucg)
    
      
    %locally update cost
    ind = find(candidategroups == ucg(i));
    num=length(ind);
    
    
    
    if(num<5)
        continue;
    end


   % fprintf('Candidate group of size %d...\n',num);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%% try to merge not all at once but 1 by 1
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    cand1 = ind(1);
    Dnzc = A(:,cand1);
    Pnzc = A(:,cand1);
    Dzc = 1-A(:,cand1);
    Pzc = 1-A(:,cand1);
    
    for o=2:num
        % merge group-cand1 with group ind(o)?
        
%         if(ismember(ind(o),cand1))
%             continue;
%         end
    
        %newind = [cand1 ind(o)];
        
        %numnew = length(newind);
        cis = [sum(Ny(cand1)) 1]; % ==Ny(ind(o)), always trying a size 1 cluster
        % reduce num cluster cost
        %%curcost = curcost - logstar2(m) + logstar2(m-num+1);

        % reduce cluster assignment cost
        %curcost = curcost - numnew*log2(m) + num*log2(m/numnew);
        curcost = 0;
        curcost = curcost - sum(cis.*log2(m./cis)) + sum(cis)*log2(m./sum(cis));
        
        % reduce encoding cost of 1s
        %curcost = curcost - n*numnew + n*log2(numnew+1);
        curcost = curcost - n*(sum(log2(cis+1))) + n*(log2(sum(cis)+1));
        
        % increase block-encoding cost, 
        
        % subtract
        Dnzm = [Dnzc A(:,ind(o))];
        Pnzm = [Pnzc A(:,ind(o))];
        Dzm = [Dzc 1-A(:,ind(o))];
        Pzm = [Pzc 1-A(:,ind(o))];
        entropy_terms =  Dzm .* entropy_bits(Pzm) + Dnzm .* entropy_bits(Pnzm);
        oldc = sum(sum(entropy_terms));
        curcost = curcost - oldc;
        
        
        Dnzv = sum(Dnzm,2);
        Pnzv = Dnzv / sum(cis);
        Dzv = sum(cis)-Dnzv;
        Pzv = 1-Pnzv;

        entropy_terms =  Dzv .* entropy_bits(Pzv) + Dnzv .* entropy_bits(Pnzv);
        curcost = curcost + (sum(entropy_terms));
    
    
    
        % check if better cost
        if(curcost<=0) % if final cost difference less than 0, merge!
          % fprintf('Current cost is %f, merging group of size %d at %d\n', curcost, sum(cis), o);
           % pause

          cand1 = [cand1 ind(o)];
           
          Dnzc = Dnzv;
          Pnzc = Pnzv;
          Dzc = Dzv;
          Pzc = Pzv;
           
        % else %don't merge
        end
    
    end % for 1 by 1 iteration
    
    if(length(cand1)>1)
%        if(length(cand1)<num)
%         fprintf('Candidates %d, merged %d\n',num, length(cand1));
%        end
       
       newind = cand1;
       % Ny and Qy are going to change
       Ny(newind) = 0;
       Ny(min(newind)) = length(newind);

       Qy(newind) = min(newind);
    end
    
end % candidate groups


end












